package com.fer.labust.diverassistant;

import java.util.ArrayList;

import com.google.android.gms.maps.model.Marker;

import android.content.Context;
import android.net.UrlQuerySanitizer.ValueSanitizer;
import android.util.Log;
import android.view.DragEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.CheckedTextView;
import android.widget.TextView;

public class MarkerArrayAdapter extends ArrayAdapter<Marker>{
	private final Context context;
	private ArrayList<Marker> items;
	
	public MarkerArrayAdapter(Context context, int textViewResourceId,ArrayList<Marker> items) {
		super(context, textViewResourceId);
		this.items = items;
		this.context = context;
	}
	
	@Override
	public void add(Marker object) {		
		super.add(object);
	}
	
	@Override	
	public View getView(int position, View convertView, ViewGroup parent) {			
		View view = convertView;
		if(view == null){
			 LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	            view = inflater.inflate(R.layout.marker, null);
		}
		Marker marker = items.get(position);
		if (marker!= null) {
            // My layout has only one TextView
			CheckedTextView itemView = (CheckedTextView) view.findViewById(R.id.marker);
            
            if (itemView != null) {
                // do whatever you want with your string and long            	
                itemView.setText("Marker " + marker.getTitle());
            }
         }
		
		return view;
	}

}
