package com.fer.labust.diverassistant;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import labust.tritech.DefaultMessageList;

import com.fer.labust.diverassistant.MainActivity.CommunicationSectionFragment;
import com.fer.labust.diverassistant.MainActivity.MapSectionFragment;
import com.fer.labust.lawnmower.model.Point;

import android.location.Location;
import android.location.LocationManager;
import android.location.LocationProvider;
import android.util.Log;

public class Parse extends Thread{

	private LocationManager locationManager;
	private String mocLocationProvider;
	public byte[] payloadmsg;
	public Boolean[] payb = new Boolean[48];
	public byte[] payc = new byte[6];
	public boolean new_data_flag = false;
	public boolean run_flag = true;
	long x, y, x_old = 50, y_old = 50, msg, predef;
	int kmlBatch = 0;
	double x_init, y_init, x_res, y_res, depth;
	private String LOG_TAG = "PARSE:";
	List<Point> receivedPoints;
	private MapSectionFragment mapSectionFragment;
	
	String mssg = "";
	private CommunicationSectionFragment bc;	

	public Parse(LocationManager locationManager, String mocLocationProvider,
			CommunicationSectionFragment chat) throws IOException {
		bc = chat;
		this.locationManager = locationManager;
	    this.mocLocationProvider = mocLocationProvider;
	    this.receivedPoints = new ArrayList<Point>();
	}
	
	public void run() {
		while(run_flag) {
			synchronized(this) {
				try {
					this.wait();
				}
				catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			payc = payloadmsg;		
			String resultMessage = "";
			for(int i = 0; i < 6; i++) {
				Log.e("payc", Byte.toString(payc[i]));
				for(int j = 0; j < 8; j++) {
					if ((payc[i] & (1 << j)) != 0) {
						payb[(5-i)*8+j] = true;
						resultMessage+="1";
					}
					else {
						payb[(5-i)*8+j] = false;
						resultMessage+="0";
					}
				}
			}
			Log.e(LOG_TAG, resultMessage + " type " + msg_build(44, 4));
			msg_type((short) msg_build(44, 4));			
			bc.getActivity().runOnUiThread(new Runnable() {
				public void run() {
					if (!mssg.isEmpty())
						bc.mConversationArrayAdapter.add(mssg);
					 bc.getActivity().getActionBar().setTitle(mssg);
					
					mssg = "";
				}
			});

			new_data_flag = false;
		}
	}


	private void msg_type(short m_type) {
		Log.e("m_type", Short.toString(m_type));
		long defaultMessagenumber;
		long expectedZeroCount = 0;
		long actualZeroCount = 0;
		DefaultMessageList defList = new DefaultMessageList();
		switch (m_type) {
		case 0:
			x = msg_build(22,22); //lat ddmm.mm
			y = msg_build(0,22); //long dddmm.mm
			x_init = x/10000 + (x % 10000.0) / 6000 - 90; // u x_init je lat u decimalnim stupnjevima do tocnosti 2 decimale minute ddmm.mm --> dd.ddddddd...
			y_init = y/10000 + (y % 10000.0) / 6000 - 180; // u y_init je lon u decimalnim stupnjevima do tocnosti 2 decimale minute ddmm.mm --> dd.ddddddd...
			x_old = 50; 
			y_old = 50;
			byte[] sendpayload = new byte[6];
			for(int i = 0; i <6; i++) {
				sendpayload[i] = payc[i];
			}
			Log.e(LOG_TAG, "x = " + Long.toString(x) + " y = " + Long.toString(y));
			Log.e(LOG_TAG, "x_init = " + Double.toString(x_init) + " y_init = " + Double.toString(y_init));
//			bc.sendMessage(sendpayload);
			break;
		case 1:
			x = msg_build(19,18); // za case 2 x je lat u decimalnim minutama, samo do jedinice minute, do tocnosti 4 decimale minute m.mmmm
			y = msg_build(1,18); // za case 2 y je lon u decimalnim minutama, samo do jedinice minute, do tocnosti 4 decimale minute m.mmmm
			if ((x/10000.0 - ((x_init*60) % 10)) < -5)
				x_res = (Math.floor(x_init*6+1) + x/100000.0)/6;
			else if ((x/10000.0 - ((x_init*60) % 10)) > 5)
				x_res = (Math.floor(x_init*6-1) + x/100000.0)/6;
			else
				x_res = (Math.floor(x_init*6) + x/100000.0)/6;
			if ((y/10000.0 - ((y_init*60) % 10)) < -5)
				y_res = (Math.floor(y_init*6+1) + y/100000.0)/6;
			else if ((y/10000.0 - ((y_init*60) % 10)) > 5)
				y_res = (Math.floor(y_init*6-1) + y/100000.0)/6;
			else
				y_res = (Math.floor(y_init*6) + y/100000.0)/6;
			new_pos(x_res, y_res);
			x_old = (long) (x_res*60%0.01*10000);
			y_old = (long) (y_res*60%0.01*10000);
			x_init = (Math.floor(x_res*6000)) / 6000.0;
			y_init = (Math.floor(y_res*6000)) / 6000.0;
			depth = msg_build(37,7)/2.0;
//			mssg = "Depth = " + Double.toString(depth) + "m.";
			// 1 msg To-Do
			break;
		case 2:
			x = msg_build(30,7); // za case 3 x je lat u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
			y = msg_build(23,7); // za case 3 y je lon u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
			if ((x - x_old) < -50)
				x_init += 0.01/60;
			if ((x - x_old) > 50)
				x_init -= 0.01/60;
			if ((y - y_old) < -50)
				y_init += 0.01/60;
			if ((y - y_old) > 50)
				y_init -= 0.01/60;
			x_old = x;
			y_old = y;
			depth = msg_build(37,7)/2.0;
			x_res = x_init + x/10000.0/60;
			y_res = y_init + y/10000.0/60;
			new_pos(x_res, y_res);
			for (int k = 0; k < 3; k++) {
				mssg += String.valueOf(Character.forDigit((int) msg_build(k*6,6), 35));
			}
			mssg = new StringBuffer(mssg).reverse().toString();
//			mssg += ", Depth = " + Double.toString(depth) + "m.";
			break;
		case 3:
			break;
		case 4:
			x = msg_build(23,14);
			y = msg_build(9,14);
			x_old = x % 100;
			y_old = y % 100;
			if ((x/10000.0 - (x_init*60)%1) < -0.5)
				x_res = Math.floor(x_init*60 + 1) + x/10000.0;
			else if ((x/10000.0 - (x_init*60)%1) > 0.5)
				x_res = Math.floor(x_init*60 - 1) + x/10000.0;
			else
				x_res = Math.floor(x_init*60) + x/10000.0;
			if ((y/10000.0 - (y_init*60)%1) < -0.5)
				y_res = Math.floor(y_init*60 + 1) + y/10000.0;
			else if ((y/10000.0 - (y_init*60)%1) > 0.5)
				y_res = Math.floor(y_init*60 - 1) + y/10000.0;
			else
				y_res = Math.floor(y_init*60) + y/10000.0;
			new_pos(x_res, y_res);
			x_init = (Math.floor(x_res*6000)) / 6000.0;
			y_init = (Math.floor(y_res*6000)) / 6000.0;
			depth = msg_build(37,7)/2.0;
			predef = msg_build(4,5);
			
			mssg += " Poruka " + defList.getDefaultMessage((int)predef);
			break;
		case 5:
			x = msg_build(30,7); // za case 3 x je lat u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
			y = msg_build(23,7); // za case 3 y je lon u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
			if ((x - x_old) < -50)
				x_init += 0.01/60;
			if ((x - x_old) > 50)
				x_init -= 0.01/60;
			if ((y - y_old) < -50)
				y_init += 0.01/60;
			if ((y - y_old) > 50)
				y_init -= 0.01/60;
			x_old = x;
			y_old = y;
			depth = msg_build(37,7)/2.0;
			x_res = x_init + x/10000.0/60;
			y_res = y_init + y/10000.0/60;
			new_pos(x_res, y_res);
			defaultMessagenumber = msg_build(18,5);
			for (int k = 0; k < 3; k++) {
				mssg += String.valueOf(Character.forDigit((int) msg_build(k*6,6), 35));
			}
			mssg = new StringBuffer(mssg).reverse().toString();
			mssg += ", Depth = " + Double.toString(depth) + "m." + " Poruka br. " + defList.getDefaultMessage((int)predef);;
			break;
		case 6:
		
			break;
		case 7:
			x = msg_build(30,7); // za case 7 x je lat u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
			y = msg_build(23,7); // za case 7 y je lon u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
			if ((x - x_old) < -50)
				x_init += 0.01/60;
			if ((x - x_old) > 50)
				x_init -= 0.01/60;
			if ((y - y_old) < -50)
				y_init += 0.01/60;
			if ((y - y_old) > 50)
				y_init -= 0.01/60;
			x_old = x;
			y_old = y;
			depth = msg_build(37,7)/2.0;
			x_res = x_init + x/10000.0/60;
			y_res = y_init + y/10000.0/60;
			new_pos(x_res, y_res);
			long kmlMessageNumber = msg_build(20,3) + this.kmlBatch * 8;
			long xKml = msg_build(10,10);
			long yKml = msg_build(0,10); //__.mmm_
			double xPoint = (((long) (x_init * 60)) + xKml/1000.0)/60.0;
			double yPoint = (((long) (y_init * 60)) + yKml/1000.0)/60.0;
			Point point = new Point(xPoint, yPoint, kmlMessageNumber);
			this.receivedPoints.add(point);
			Log.e(LOG_TAG, Long.toString(kmlMessageNumber));
			Log.e(LOG_TAG, Double.toString(xPoint)  + " " + Double.toString(yPoint));
			break;		
		case 8:
			
			break;
		case 9:
			expectedZeroCount = msg_build(0, 6);
			actualZeroCount = countZeroes(6, 43);
			if(expectedZeroCount == actualZeroCount){
				x = msg_build(30,7); // za case 3 x je lat u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
				y = msg_build(23,7); // za case 3 y je lon u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
				if ((x - x_old) < -50)
					x_init += 0.01/60;
				if ((x - x_old) > 50)
					x_init -= 0.01/60;
				if ((y - y_old) < -50)
					y_init += 0.01/60;
				if ((y - y_old) > 50)
					y_init -= 0.01/60;
				x_old = x;
				y_old = y;
				depth = msg_build(37,7)/2.0;
				x_res = x_init + x/10000.0/60;
				y_res = y_init + y/10000.0/60;
				new_pos(x_res, y_res);			
				for (int k = 0; k < 3; k++) {
					mssg += String.valueOf(Character.forDigit((int) msg_build(k*6 +6,6), 35));
				}
				mssg = new StringBuffer(mssg).reverse().toString();
				mssg += ", Depth = " + Double.toString(depth) + "m.";
			}
			else {
				bc.sendMessage("8");
			}
			break;
		case 10:
			expectedZeroCount = msg_build(0, 6);
			actualZeroCount = countZeroes(6, 43);
			if(expectedZeroCount == actualZeroCount){
				x = msg_build(30,7); // za case 3 x je lat u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
				y = msg_build(23,7); // za case 3 y je lon u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
				if ((x - x_old) < -50)
					x_init += 0.01/60;
				if ((x - x_old) > 50)
					x_init -= 0.01/60;
				if ((y - y_old) < -50)
					y_init += 0.01/60;
				if ((y - y_old) > 50)
					y_init -= 0.01/60;
				x_old = x;
				y_old = y;
				depth = msg_build(37,7)/2.0;
				x_res = x_init + x/10000.0/60;
				y_res = y_init + y/10000.0/60;
				new_pos(x_res, y_res);			
				for (int k = 0; k < 3; k++) {
					mssg += String.valueOf(Character.forDigit((int) msg_build(k*6 +6,6), 35));
				}
				mssg = new StringBuffer(mssg).reverse().toString();
				mssg += ", Depth = " + Double.toString(depth) + "m.";
			}
			else {
				bc.sendMessage("8");
			}
			break;
		case 11:
//			expectedZeroCount = msg_build(0, 6);
//			actualZeroCount = countZeroes(6, 43);
//			if(expectedZeroCount == actualZeroCount){
			x = msg_build(30,7); // za case 7 x je lat u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
			y = msg_build(23,7); // za case 7 y je lon u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
			if ((x - x_old) < -50)
				x_init += 0.01/60;
			if ((x - x_old) > 50)
				x_init -= 0.01/60;
			if ((y - y_old) < -50)
				y_init += 0.01/60;
			if ((y - y_old) > 50)
				y_init -= 0.01/60;
			x_old = x;
			y_old = y;
			depth = msg_build(37,7)/2.0;
			x_res = x_init + x/10000.0/60;
			y_res = y_init + y/10000.0/60;
			new_pos(x_res, y_res);
			defaultMessagenumber = msg_build(18,5);
			if(defaultMessagenumber == 6){
				this.kmlBatch+=1;
			}
			if(defaultMessagenumber == 7) {
				this.kmlBatch = 0;
				
				MapSectionFragment.getInstance().getActivity().runOnUiThread(new Runnable() {
					public void run() {
						MapSectionFragment.getInstance().addPointsAndGeneratePolygon(receivedPoints);
					}
				});
			}
			mssg+= " Poruka: " + defList.getDefaultMessage((int)defaultMessagenumber);
			Log.e(LOG_TAG, Long.toString(defaultMessagenumber));
//			}
//			else {
//				bc.sendMessage("8");
//			}
			break;
		case 12:
			expectedZeroCount = msg_build(0, 6);
			actualZeroCount = countZeroes(6, 43);
			if(expectedZeroCount == actualZeroCount){
			x = msg_build(30,7); // za case 7 x je lat u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
			y = msg_build(23,7); // za case 7 y je lon u decimalnim minutama, samo 3. i 4. decimala minute, _.__mm
			if ((x - x_old) < -50)
				x_init += 0.01/60;
			if ((x - x_old) > 50)
				x_init -= 0.01/60;
			if ((y - y_old) < -50)
				y_init += 0.01/60;
			if ((y - y_old) > 50)
				y_init -= 0.01/60;
			x_old = x;
			y_old = y;
			depth = msg_build(37,7)/2.0;
			x_res = x_init + x/10000.0/60;
			y_res = y_init + y/10000.0/60;
			new_pos(x_res, y_res);
			defaultMessagenumber = msg_build(18,5);
			if(defaultMessagenumber == 6){
				this.kmlBatch+=1;
			}
			if(defaultMessagenumber == 7) {
				this.kmlBatch = 0;
				MapSectionFragment.getInstance().addPointsAndGeneratePolygon(this.receivedPoints);
			}
			for (int k = 0; k < 2; k++) {
				mssg += String.valueOf(Character.forDigit((int) msg_build(k*6 +6,6), 35));
			}
			mssg = new StringBuffer(mssg).reverse().toString();
			mssg+= " Poruka: " + defList.getDefaultMessage((int)predef);
			}
			else {
				bc.sendMessage("8");
			}
			break;
		case 13:
			
			break;
		default:
			Log.e(LOG_TAG, "NIJE DOBRO!!!");
		}
			
		
	}
	//pretvara binarno u decimalno
	private long msg_build(int from, int size) {
		long msg = 0;
		for (int i = from; i < (from + size); i++) {
			long value = (payb[i] ? 1 : 0) << (i - from);
			msg = msg | value;
		}
		return msg;
	}
	
	private long countZeroes(int from, int size){
		long zeroCount = 0;
		for (int i = from; i < (from + size); i++) {
			if(!payb[i].booleanValue()){
				zeroCount +=1;
			}
		}
		return zeroCount;
	}
	//postavlja novu lokaciju
	private void new_pos(double latitude, double longitude) {
		Location location = new Location(mocLocationProvider);
    	location.setLatitude(latitude);
    	location.setLongitude(longitude);
    	location.setAltitude(0.0);
    	location.setProvider(mocLocationProvider);
    	location.setTime(System.currentTimeMillis());
    	Log.e(LOG_TAG, location.toString());

//    	locationManager.setTestProviderStatus(mocLocationProvider,
//    			LocationProvider.AVAILABLE, null, System.currentTimeMillis());
    	locationManager.setTestProviderLocation(mocLocationProvider, location);
	}
}